function P = DivInSet(U,L,PSize)
% *************************************************************************
% Initial Pop Generation Procedure
% An attached funtion to the FSEDA code
% *************************************************************************
% The FSEDA Code is created on March 27, 2019 by A. Hedar & A.A. Allam
% The code is modified on Sep. 20, 2020.
% *************************************************************************

% Intial Parameters
% =================
n = length(U); % No. of variables
red = (U-L)/(PSize/n);
freq = zeros(n,4);
currentPSize=1;
while(currentPSize <= PSize)
    % Generate a trial solution
    trial = zeros(n,1);
    for var=1:n
        % Compute frequency complements
        sm = 0; total = 0;        
        for i=1:4
            sm = sm+freq(var,i);
        end	
        for i=1:4	
            rfreq(i) = sm - freq(var,i);
            total = total+rfreq(i);
        end
        % Choose a sub-range
        if total==0
            index = ceil(4*rand);
        else 
            j = ceil(total*rand);
            index=1;
            while j > rfreq(index) 
                j = j-rfreq(index);
                index = index+1;
            end
        end        		
        % Update freq
        freq(var,index) = freq(var,index)+1;
        % Select a value in the sub-range
        range= U(var)-L(var);
        r = rand;
        value = L(var)+(index-1)*(range/4) + (r*range/4);
        trial(var) = value;
    end 
    Sol = trial;
    % Check accepting Sol
    indx = 1; check = 1;
    while(indx < currentPSize && check == 1)        
        if norm((Sol-P(:,indx))./red) < 1
        	check = 0;
        end        
        indx = indx + 1;
    end		
    % Adding a new Solution
    if check == 1
        P(:,currentPSize) = Sol;                
        currentPSize = currentPSize+1;
    end
end