function [y] = Sampling(f,x,Nsamp)
% *************************************************************************
% Sampling Procedure
% An attached funtion to the FSEDA code
% *************************************************************************
% The FSEDA Code is created on March 27, 2019 by A. Hedar & A.A. Allam
% The code is modified on Sep. 20, 2020.
% *************************************************************************
z = zeros(1,Nsamp);
for i = 1:Nsamp
    z(i) = feval(f,x);
end
if Nsamp <= 100
    mu1 = zeros(1,Nsamp);
    z = sort(z);
    yi = median(z);    
    eps = abs(z(Nsamp)-z(1))/100*Nsamp;
    n = 0;
    for i = 1 : Nsamp
        if z(i) <= yi - eps
            mu1(i) = 0;
        elseif z(i) <= yi
            mu1(i) = 1 -(yi - z(i))/(eps);
            n = n + mu1(i);
        elseif z(i) <= yi + eps
            mu1(i) =(yi+eps - z(i))/(eps);
            n = n + mu1(i);
        else
            mu1(i) = 0;
        end
        y = sum(mu1.*z)/ n;        
    end    
else
    y =mean(z);
end
