function [xOUT,fOUT,xMIN,fMIN,fCOUNT] = fminLocalSearch(fs,xIN,fIN,xMIN,fMIN,nEvals)
% Local search method based on Matlab codes for 
% Nelder-Mead and Unconstrained Optimization Methods

global noise nSample

noise = 2;
options.MaxFunEvals = nEvals; 

fOUT = fIN;
xOUT = xIN;    
xTrial = xIN;

% Nelder-Mead Method
[xOUT1,fOUT1,~,output] = fminsearch(fs,xTrial,options);
fCOUNT = nSample * output.funcCount; 
if fOUT1 < fIN
    fOUT = fOUT1;
    xOUT = xOUT1;   
    xTrial = xOUT;
    fIN = fOUT1;
    if fOUT1 < fMIN
        xMIN = xOUT1;
        fMIN = fOUT1;
    end    
end

% Unconstrained Optimization Method
[xOUT2,fOUT2,~,output] = fminunc(fs,xTrial,options);
fCOUNT = fCOUNT + nSample * output.funcCount;
if fOUT2 < fIN
    fOUT = fOUT2;
    xOUT = xOUT2;     
    if fOUT2 < fMIN
        xMIN = xOUT2;
        fMIN = fOUT2;
    end    
end
noise = 1;
end

