% *************************************************************************
% A run example of the FSEDA code using ftest function 
% *************************************************************************
% The FSEDA Code is created on March 27, 2019 by A. Hedar & A.A. Allam
% The code is modified on Sep. 20, 2020.
% *************************************************************************
addpath('TestFunctions')

test = input('Please, enter test function no. (from 1 to 6) :: ');
dim = input('Please, enter the dimension size (30 or 100) :: ');

output = 1;

if test == 1
    U = 30*ones(dim,1);
    L = -15*ones(dim,1);
    [xmin,fmin,gmin] = FSEDA(@ftest1,U,L);
elseif test == 2
    U = 10*ones(dim,1);
    L = -U;
    [xmin,fmin,gmin] = FSEDA(@ftest2,U,L);
elseif test == 3
    U = 5.12*ones(dim,1);
    L = -U;
    [xmin,fmin,gmin] = FSEDA(@ftest3,U,L);
elseif test == 4
    U = 5.12*ones(dim,1);
    L = -U;
    [xmin,fmin,gmin] = FSEDA(@ftest4,U,L);
elseif test == 5
    U = 5.12*ones(dim,1);
    L = -U;
    [xmin,fmin,gmin] = FSEDA(@ftest5,U,L);
elseif test == 6
    U = 600*ones(dim,1);
    L = -U;
    [xmin,fmin,gmin] = FSEDA(@ftest6,U,L);
else
    disp('Only, test functions 1 to 6 are avilable in this test.')
    output = 0;
end

if output == 1
    dispR1 = ['Best f-value with sampling is :: ',num2str(fmin)];                
    disp(dispR1)
    dispR2 = ['Exact best f-value is :: ',num2str(gmin)];                
    disp(dispR2)
end    